/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */
package gov.va.med.vistalink.management.action;

import gov.va.med.vistalink.adapter.cci.VistaLinkResourceException;
import gov.va.med.vistalink.adapter.spi.ConnectorConfigurator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

/**
 * Struts action to list configuration entries.
 * 
 */
public class ConfiguratorListAction extends VistaLinkActionBase {
	/*
	 * Generated Methods
	 */

	private static final Logger logger = Logger.getLogger(ConfiguratorListAction.class);

	/**
	 * Method execute
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return ActionForward
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) {

		// security check
		try {
			checkIsUserInRole(request, DEPLOYER_OR_ADMIN_OR_OPERATOR);
		} catch (SecurityException e) {
			logger.warn("Access attempt without sufficient privileges" + e.getMessage());
			ActionErrors errors = getGlobalActionErrors(request);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("configurator.nopriv", new Object[] { e.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, errors);
			return mapping.findForward("nopriv");
		}
		
		addPageRenderedTime(request);
		addSessionTimeoutWarning(request);
		ConnectorConfigurator cc = new ConnectorConfigurator();
		request.setAttribute("definitionLabel", definitionLabel);
		try {
			request.setAttribute("configFileSize", Integer.valueOf(cc.getConfigFileEntrySize()));
			request.setAttribute("configFilePath", cc.getConfigUrlStr());
			request.setAttribute("configFileUnencryptedCount", Integer.valueOf(cc.getUnencryptedCount()));
			request.setAttribute("connectorConfigList", cc.getConnectorArray());
			request.setAttribute("configFileEncryptionType", cc.isEncryptionScoped() ? "Scoped" : "Not Scoped");
		} catch (VistaLinkResourceException e) {
			logger.error("Could not retrieve connector config information", e);
			ActionErrors errors = getGlobalActionErrors(request);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("configurator.generalError", new Object[] {
					"retrieving configuration file", e.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, errors);
		} catch (Exception e) {
			logger.error("Could not retrieve connector config information", e);
			ActionErrors errors = getGlobalActionErrors(request);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("configurator.generalError", new Object[] {
					"retrieving configuration file", e.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, errors);
		}
		return mapping.findForward("success");
	}
	
}