/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */
package gov.va.med.vistalink.management.action;

import gov.va.med.vistalink.adapter.spi.ConnectorInfoVO;
import gov.va.med.vistalink.adapter.spi.VistaLinkSystemInfoVO;
import gov.va.med.vistalink.console.IServerHelper;
import gov.va.med.vistalink.console.ServerHelperException;
import gov.va.med.vistalink.console.ServerHelperFactory;
import gov.va.med.vistalink.console.ServerHelperNotRunningException;
import gov.va.med.vistalink.console.ServerHelperWebLogic;
import gov.va.med.vistalink.management.ServerTO;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.InetAddress;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.net.UnknownHostException;
import java.util.HashMap;
import java.util.Map;

import javax.management.MBeanServerConnection;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;
import javax.management.remote.JMXConnector;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import weblogic.management.NoAccessRuntimeException;

/**
 * Struts action to display a live connector's details.
 * 
 */
public class DisplayConnectorAction extends VistaLinkActionBase {
	/*
	 * Generated Methods
	 */

	private static final Logger logger = Logger.getLogger(DisplayConnectorAction.class);

	private static final String CONN_DETAIL_VO_ATTR_KEY = "connectorDetailVO";
	private static final String CONN_RESOLVED_IPADDRESS_ATTR_KEY = "resolvedIPAddress";
	private static final String CONN_DETAIL_ERROR_MSG = "Error retrieving connector detail: ";

	/**
	 * Override default roles, add MONITOR to allow viewing top-level server choice page
	 */
	private static final byte NORMAL_ROLES_PLUS_MONITOR = VistaLinkActionBase.DEPLOYER_OR_ADMIN_OR_OPERATOR
			| ROLE_MONITOR;

	// text vars
	private static final String TEXT_PROB_MBEAN_ATTR = "problem getting remote MBean attribute: ";

	/**
	 * Method execute
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return ActionForward
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) {

		// security check
		try {
			checkIsUserInRole(request, NORMAL_ROLES_PLUS_MONITOR);
		} catch (SecurityException e) {
			logger.warn("Access attempt without sufficient privileges" + e.getMessage());
			ActionErrors errors = getGlobalActionErrors(request);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("configurator.nopriv", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, errors);
			return mapping.findForward("nopriv");
		}

		addPageRenderedTime(request);
		addSessionTimeoutWarning(request);
		ServerTO serverTO = new ServerTO();
		IServerHelper serverHelper;
		String vlConnObjectNameStr = request.getParameter("connectorDetailObjectName");
		JMXConnector jmxConnector = null;
		ConnectorInfoVO ciVO = new ConnectorInfoVO();
		String IPAddressResolved = "";

		try {
			String serverHelperConstructorProperties = URLDecoder.decode(request.getParameter("server"), "UTF-8");
			serverHelper = ServerHelperFactory.getServerHelper(serverHelperConstructorProperties);
			serverTO.setServerConstructorAttributes(URLEncoder.encode(serverHelper
					.getServerHelperConstructorProperties(), "UTF-8"));
			serverTO.setServerName(serverHelper.getDisplayNameFullyLocationQualified());
			try {
				serverTO.setAdminServer(((ServerHelperWebLogic) serverHelper).isLocalAndAdminServer());
			} catch (ServerHelperException e1) {
				logger
						.warn(
								"Could not determine if target server is admin server; not enabling edit config file link.",
								e1);
			}

			ObjectName vlConnObjectName = new ObjectName(vlConnObjectNameStr);

			// get local or remote connection
			jmxConnector = serverHelper.getJmxConnector();
			MBeanServerConnection mBeanServerConn = jmxConnector.getMBeanServerConnection();

			ciVO.setJcaDeploymentStateString(getStringAttribute(mBeanServerConn, vlConnObjectName, "DeploymentState",
					request));
			ciVO.setJcaJndiName(getStringAttribute(mBeanServerConn, vlConnObjectName, "JndiNameActual", request));
			ciVO.setCfgJndiName(getStringAttribute(mBeanServerConn, vlConnObjectName, "JndiNameCustomProp", request));
			ciVO.setCfgIpAddress(getStringAttribute(mBeanServerConn, vlConnObjectName, "CfgIpAddress", request));

			// get resolved IP address
			try {
				IPAddressResolved = (InetAddress.getByName(ciVO.getCfgIpAddress())).getHostAddress();
			} catch (UnknownHostException e) {
				IPAddressResolved = e.getMessage();
			}
			
			ciVO.setCfgPort(getIntAttribute(mBeanServerConn, vlConnObjectName, "CfgPort", request));
			ciVO.setHlthConnectionAuthFailureCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
					"HlthConnectionAuthFailureCount", request));
			ciVO.setHlthConnectionFailureCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
					"HlthConnectionFailureCount", request));
			ciVO.setHlthDivisionMismatchCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
					"HlthDivisionMismatchCount", request));
			ciVO.setHlthIdentityFailureCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
					"HlthIdentityFailureCount", request));
			ciVO.setHlthProductionMismatchCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
					"HlthProductionMismatchCount", request));
			ciVO.setPerfCreateConnectionHandleAvgMillis(getDoubleAttribute(mBeanServerConn, vlConnObjectName,
					"PerfCreateConnectionHandleAvgMillis", request));
			ciVO.setPerfMatchManagedConnectionAvgMillis(getDoubleAttribute(mBeanServerConn, vlConnObjectName,
					"PerfMatchManagedConnectionAvgMillis", request));
			ciVO.setCfgTimeout(getLongAttribute(mBeanServerConn, vlConnObjectName, "CfgTimeout", request));
			ciVO.setCfgTimeoutAlwaysUseDefaultAsMin(getBooleanAttribute(mBeanServerConn, vlConnObjectName,
					"CfgTimeoutAlwaysUseDefaultAsMin", request));

			try {
				ciVO.setPlatformSpecificItemsMap((Map) mBeanServerConn.getAttribute(vlConnObjectName,
						"VendorSpecificProperties"));
			} catch (Exception e) {
				ciVO.setPlatformSpecificItemsMap(new HashMap());
				logger.error(TEXT_PROB_MBEAN_ATTR + e.getMessage());
				ActionErrors actionErrors = getGlobalActionErrors(request);
				actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
						.getMessage() }));
				request.setAttribute(Globals.ERROR_KEY, actionErrors);
			}

			if (!("Suspended".equals(ciVO.getJcaDeploymentStateString()))) {
				ciVO.setJndiMismatch(ConnectorInfoVO.isJndiMismatch(ciVO.getJcaJndiName(), ciVO.getCfgJndiName()));
			} else {
				// boolean defaults to false anyway but let's make it explicit
				ciVO.setJndiMismatch(false);
			}

			try {
				ciVO.setCfgStationNumbers((String[]) mBeanServerConn.getAttribute(vlConnObjectName,
						"QueryMappedInstitutions"));
			} catch (Exception e) {
				ciVO.setCfgStationNumbers(new String[] { "Error: " + e.getMessage() });
				logger.error("Could not retrieve institution mappings: " + e.getMessage());
				ActionErrors actionErrors = getGlobalActionErrors(request);
				actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector",
						new Object[] { "Could not retrieve institution mappings: " + e.getMessage() }));
				request.setAttribute(Globals.ERROR_KEY, actionErrors);
			}

			try {
				Map mSystemMap = (Map) mBeanServerConn.getAttribute(vlConnObjectName, "QueryMSystemMap");
				if (mSystemMap != null) {
					VistaLinkSystemInfoVO mVO = new VistaLinkSystemInfoVO(mSystemMap);
					String introFixed = mVO.getIntroTextReplaceBrWithLineBreak();
					mVO.setIntroText(introFixed);
					ciVO.setMumpsSystemInfo(mVO);
				}
			} catch (Exception e) {
				VistaLinkSystemInfoVO mVO = new VistaLinkSystemInfoVO();
				mVO.setErrorMessage(e.getMessage());
				ciVO.setMumpsSystemInfo(mVO);
				logger.error("Could not retrieve M system info: " + e.getMessage());
				ActionErrors actionErrors = getGlobalActionErrors(request);
				actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector",
						new Object[] { "Could not retrieve M system info: " + e.getMessage() }));
				request.setAttribute(Globals.ERROR_KEY, actionErrors);
			}

		} catch (UnsupportedEncodingException e) {

			logger.error(e);
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);

		} catch (IOException e) {
			// special catch here so we can display special error message for case where could not connect to server;
			// no logger.error necessary
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.serverNotRunning"));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (ServerHelperNotRunningException e) {
			// don't log error, server not running is common condition
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (ServerHelperException e) {
			logger.error(CONN_DETAIL_ERROR_MSG, e);
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (MalformedObjectNameException e) {
			logger.error(CONN_DETAIL_ERROR_MSG, e);
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (NoAccessRuntimeException e) {
			logger.warn("Access attempt without sufficient privileges" + e.getMessage());
			ActionErrors errors = getGlobalActionErrors(request);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("configurator.nopriv", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, errors);
		} catch (Exception e) {
			logger.error(CONN_DETAIL_ERROR_MSG, e);
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} finally {

			request.setAttribute("server", serverTO);
			if (jmxConnector != null) {
				try {
					jmxConnector.close();
				} catch (IOException e) {
					logger.error("Problem closing jmxConnector: ", e);
				}
			}
		}

		request.setAttribute(CONN_DETAIL_VO_ATTR_KEY, ciVO);
		request.setAttribute(CONN_RESOLVED_IPADDRESS_ATTR_KEY, IPAddressResolved);
		return mapping.findForward("success");

	}

	private String getStringAttribute(MBeanServerConnection mBeanServerConn, ObjectName objectName,
			String attributeName, HttpServletRequest request) {
		String returnVal = null;
		try {
			returnVal = (String) mBeanServerConn.getAttribute(objectName, attributeName);
		} catch (Exception e) {
			logger.error(TEXT_PROB_MBEAN_ATTR + e.getMessage());
			returnVal = "n/a";
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		}
		return returnVal;
	}

	private int getIntAttribute(MBeanServerConnection mBeanServerConn, ObjectName objectName, String attributeName,
			HttpServletRequest request) {
		int returnVal;
		try {
			returnVal = ((Integer) mBeanServerConn.getAttribute(objectName, attributeName)).intValue();
		} catch (Exception e) {
			logger.error(TEXT_PROB_MBEAN_ATTR + e.getMessage());
			returnVal = -1;
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		}
		return returnVal;
	}

	private long getLongAttribute(MBeanServerConnection mBeanServerConn, ObjectName objectName, String attributeName,
			HttpServletRequest request) {
		long returnVal;
		try {
			returnVal = ((Long) mBeanServerConn.getAttribute(objectName, attributeName)).longValue();
		} catch (Exception e) {
			logger.error(TEXT_PROB_MBEAN_ATTR + e.getMessage());
			returnVal = -1;
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		}
		return returnVal;
	}

	private boolean getBooleanAttribute(MBeanServerConnection mBeanServerConn, ObjectName objectName,
			String attributeName, HttpServletRequest request) {
		boolean returnVal;
		try {
			returnVal = ((Boolean) mBeanServerConn.getAttribute(objectName, attributeName)).booleanValue();
		} catch (Exception e) {
			logger.error(TEXT_PROB_MBEAN_ATTR + e.getMessage());
			returnVal = false;
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		}
		return returnVal;
	}

	private double getDoubleAttribute(MBeanServerConnection mBeanServerConn, ObjectName objectName,
			String attributeName, HttpServletRequest request) {
		double returnVal;
		try {
			returnVal = ((Double) mBeanServerConn.getAttribute(objectName, attributeName)).doubleValue();
		} catch (Exception e) {
			logger.error(TEXT_PROB_MBEAN_ATTR + e.getMessage());
			returnVal = -1;
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		}
		return returnVal;
	}
}