/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */
package gov.va.med.vistalink.management.action;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import gov.va.med.vistalink.adapter.spi.ConnectorInfoVO;
import gov.va.med.vistalink.console.IServerHelper;
import gov.va.med.vistalink.console.ServerHelperException;
import gov.va.med.vistalink.console.ServerHelperFactory;
import gov.va.med.vistalink.console.ServerHelperNotRunningException;
import gov.va.med.vistalink.console.ServerHelperWebLogic;
import gov.va.med.vistalink.jmx.IJmxHelper;
import gov.va.med.vistalink.jmx.JmxHelperFactory;
import gov.va.med.vistalink.management.ServerTO;
import gov.va.med.vistalink.management.VistaLinkConnector;
import gov.va.med.vistalink.management.VistaLinkMBeanNotFoundException;

import javax.management.MBeanServerConnection;
import javax.management.ObjectName;
import javax.management.remote.JMXConnector;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import weblogic.management.NoAccessRuntimeException;

/**
 * Struts action to display a list of live connectors on a given server.
 * 
 */
public class DisplayConnectorListAction extends VistaLinkActionBase {
	/*
	 * Generated Methods
	 */

	private static final Logger logger = Logger.getLogger(DisplayConnectorListAction.class);
	private static final String CONNS_VO_ATTR_KEY = "connectorsMap";
	private static final String CONNS_ERROR_MSG = "Error retrieving connector list: ";

	/**
	 * Override default roles, add MONITOR to allow viewing top-level server choice page
	 */
	private static final byte NORMAL_ROLES_PLUS_MONITOR = VistaLinkActionBase.DEPLOYER_OR_ADMIN_OR_OPERATOR | ROLE_MONITOR;

	/**
	 * Method execute
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return ActionForward
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) {

		// security check
		try {
			checkIsUserInRole(request, NORMAL_ROLES_PLUS_MONITOR);
		} catch (SecurityException e) {
			logger.warn("Access attempt without sufficient privileges" + e.getMessage());
			ActionErrors errors = getGlobalActionErrors(request);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("configurator.nopriv", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, errors);
			return mapping.findForward("nopriv");
		}

		addPageRenderedTime(request);
		addSessionTimeoutWarning(request);
		ServerTO serverTO = new ServerTO();
		JMXConnector jmxConnector = null;

		try {
			String serverHelperConstructorProperties = URLDecoder.decode(request.getParameter("server"), "UTF-8");
			IServerHelper serverHelper = ServerHelperFactory.getServerHelper(serverHelperConstructorProperties);
			serverTO.setServerConstructorAttributes(URLEncoder.encode(serverHelper
					.getServerHelperConstructorProperties(), "UTF-8"));
			serverTO.setServerName(serverHelper.getDisplayNameFullyLocationQualified());
			try {
				serverTO.setAdminServer(((ServerHelperWebLogic) serverHelper).isLocalAndAdminServer());
			} catch (ServerHelperException e1) {
				logger
						.warn(
								"Could not determine if target server is admin server; not enabling edit config file link.",
								e1);
			}

			Map connectorsMap = new TreeMap();
			IJmxHelper jmxHelper = JmxHelperFactory.getJmxHelper();
			jmxConnector = serverHelper.getJmxConnector();
			MBeanServerConnection mBeanServerConn = jmxConnector.getMBeanServerConnection();

			StringBuffer sb = new StringBuffer(jmxHelper.getJmxDomainForHev());
			sb.append(":Type=").append(VistaLinkConnector.getMBeanType()).append(",*");
			ObjectName vlConnQueryObjectName = new ObjectName(sb.toString());
			logger.debug("About to query with ObjectName: " + vlConnQueryObjectName);
			Set vlConnObjectNameSet = mBeanServerConn.queryNames(vlConnQueryObjectName, null);
			logger.debug("peformed queryMBeans, result size: " + vlConnObjectNameSet.size());

			if (vlConnObjectNameSet.size() < 1) {
				throw new VistaLinkMBeanNotFoundException();
			}

			Iterator vlConnSetIter = vlConnObjectNameSet.iterator();
			while (vlConnSetIter.hasNext()) {

				ObjectName vlConnObjectName = (ObjectName) vlConnSetIter.next();
				// make sure connector type is VistA
				if ("VistA".equals((String) mBeanServerConn.getAttribute(vlConnObjectName, "EisType"))) {

					ConnectorInfoVO ciVO = new ConnectorInfoVO();
					ciVO.setJcaDeploymentStateString(getStringAttribute(mBeanServerConn, vlConnObjectName, 
							"DeploymentState", request));
					ciVO.setJcaJndiName(getStringAttribute(mBeanServerConn, vlConnObjectName, "JndiNameActual",	request));
					ciVO.setCfgJndiName(getStringAttribute(mBeanServerConn, vlConnObjectName, "JndiNameCustomProp",	request));
					ciVO.setCfgIpAddress(getStringAttribute(mBeanServerConn, vlConnObjectName, "CfgIpAddress", request));
					ciVO.setCfgPort(getIntAttribute(mBeanServerConn, vlConnObjectName, "CfgPort", request));
					ciVO.setHlthConnectionAuthFailureCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
							"HlthConnectionAuthFailureCount", request));
					ciVO.setHlthConnectionFailureCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
							"HlthConnectionFailureCount", request));
					ciVO.setHlthDivisionMismatchCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
							"HlthDivisionMismatchCount", request));
					ciVO.setHlthIdentityFailureCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
							"HlthIdentityFailureCount", request));
					ciVO.setHlthProductionMismatchCount(getLongAttribute(mBeanServerConn, vlConnObjectName,
							"HlthProductionMismatchCount", request));

					if (!("Suspended".equals(ciVO.getJcaDeploymentStateString()))) {
						ciVO.setJndiMismatch(ConnectorInfoVO.isJndiMismatch(ciVO.getJcaJndiName(), ciVO
								.getCfgJndiName()));
					} else {
						// boolean defaults to false anyway but let's make it explicit
						ciVO.setJndiMismatch(false);
					}

					connectorsMap.put(vlConnObjectName.getCanonicalName(), ciVO);
				}
			}

			request.setAttribute(CONNS_VO_ATTR_KEY, connectorsMap);
			logger.debug("return Map size: " + connectorsMap.size());

		} catch (VistaLinkMBeanNotFoundException e) {
			// special catch here so we can display special error message for case where MBean is not
			// registered, meaning VL probably not deployed
			// no logger.error necessary
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.vistalinkConnectorMBeanFound"));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (UnsupportedEncodingException e) {
			logger.error(e);
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connectorListGenericError"));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (IOException e) {
			// special catch here so we can display special error message for case where could not connect to server
			// (no logger.error necessary)
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.serverNotRunning"));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (ServerHelperNotRunningException e) {
			// don't log error, server not running is common condition
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (ServerHelperException e) {
			logger.error(e);
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (NoAccessRuntimeException e) {
			logger.warn("Access attempt without sufficient privileges" + e.getMessage());
			ActionErrors errors = getGlobalActionErrors(request);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("configurator.nopriv", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, errors);
		} catch (Exception e) {
			logger.error(CONNS_ERROR_MSG, e);
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connectorListGenericError"));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} finally {
			if (jmxConnector != null) {
				try {
					jmxConnector.close();
				} catch (IOException e) {
					logger.error("Error closing JMX Connector: ", e);
				}
			}
			request.setAttribute("server", serverTO);
		}

		return mapping.findForward("success");
	}

	private int getIntAttribute(MBeanServerConnection mBeanServerConn, ObjectName objectName, String attributeName, HttpServletRequest request) {
		int returnVal;
		try {
			returnVal = ((Integer) mBeanServerConn.getAttribute(objectName, attributeName)).intValue();
		} catch (Exception e) {
			logger.error("problem getting remote MBean attribute: " + e.getMessage());
			returnVal = -1;
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		}
		return returnVal;
	}

	private long getLongAttribute(MBeanServerConnection mBeanServerConn, ObjectName objectName, String attributeName, HttpServletRequest request) {
		long returnVal;
		try {
			returnVal = ((Long) mBeanServerConn.getAttribute(objectName, attributeName)).longValue();
		} catch (Exception e) {
			logger.error("problem getting remote MBean attribute: " + e.getMessage());
			returnVal = -1;
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		}
		return returnVal;
	}

	private String getStringAttribute(MBeanServerConnection mBeanServerConn, ObjectName objectName, String attributeName, HttpServletRequest request) {
		String returnVal = null;
		try {
			returnVal = (String) mBeanServerConn.getAttribute(objectName, attributeName);
		} catch (Exception e) {
			logger.error("problem getting remote MBean attribute: " + e.getMessage());
			returnVal = "n/a";
			ActionErrors actionErrors = getGlobalActionErrors(request);
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		}
		return returnVal;
	}

}