/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */
package gov.va.med.vistalink.management.action;

import gov.va.med.vistalink.console.IServerHelper;
import gov.va.med.vistalink.console.ServerHelperException;
import gov.va.med.vistalink.console.ServerHelperFactory;
import gov.va.med.vistalink.console.ServerHelperNotRunningException;
import gov.va.med.vistalink.console.ServerHelperWebLogic;
import gov.va.med.vistalink.jmx.IJmxHelper;
import gov.va.med.vistalink.jmx.JmxHelperFactory;
import gov.va.med.vistalink.management.ServerTO;
import gov.va.med.vistalink.management.VistaLinkInstitutionMapping;
import gov.va.med.vistalink.management.VistaLinkMBeanNotFoundException;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.Map;
import java.util.Set;

import javax.management.MBeanServerConnection;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;
import javax.management.remote.JMXConnector;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import weblogic.management.NoAccessRuntimeException;

/**
 * Struts action to display the live institution mappings for a given server.
 * 
 */
public class DisplayInstitutionMappingAction extends VistaLinkActionBase {
	/*
	 * Generated Methods
	 */

	private static final Logger logger = Logger.getLogger(DisplayInstitutionMappingAction.class);

	private static final String INST_MAPPING_VO_ATTR_KEY = "instMappingMap";

	/**
	 * Override default roles, add MONITOR to allow viewing top-level server choice page
	 */
	private static final byte NORMAL_ROLES_PLUS_MONITOR = VistaLinkActionBase.DEPLOYER_OR_ADMIN_OR_OPERATOR | ROLE_MONITOR ;

	/**
	 * Method execute
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return ActionForward
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) {

		// security check
		try {
			checkIsUserInRole(request, NORMAL_ROLES_PLUS_MONITOR);
		} catch (SecurityException e) {
			logger.warn("Access attempt without sufficient privileges" + e.getMessage());
			ActionErrors errors = getGlobalActionErrors(request);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("configurator.nopriv", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, errors);
			return mapping.findForward("nopriv");
		}

		addPageRenderedTime(request);
		addSessionTimeoutWarning(request);
		ServerTO serverTO = new ServerTO();
		IJmxHelper jmxHelper = JmxHelperFactory.getJmxHelper();
		Map instMappingMap = null;
		JMXConnector jmxConnector = null;

		try {
			// parse server param
			String serverHelperConstructorProperties = URLDecoder.decode(request.getParameter("server"), "UTF-8");
			IServerHelper serverHelper = ServerHelperFactory.getServerHelper(serverHelperConstructorProperties);
			serverTO.setServerConstructorAttributes(URLEncoder.encode(serverHelper
					.getServerHelperConstructorProperties(), "UTF-8"));
			serverTO.setServerName(serverHelper.getDisplayNameFullyLocationQualified());
			try {
				serverTO.setAdminServer(((ServerHelperWebLogic) serverHelper).isLocalAndAdminServer());
			} catch (ServerHelperException e1) {
				logger
						.warn(
								"Could not determine if target server is admin server; not enabling edit config file link.",
								e1);
			}

			// retrieve institutions
			jmxConnector = serverHelper.getJmxConnector();
			// get local or remote connection
			MBeanServerConnection mBeanServerConnection = jmxConnector.getMBeanServerConnection();
			// do query to get complete object name (it varies from platform to platform)
			ObjectName instMappingObjectName = getVistaLinkInstitutionMappingObjectNameViaQuery(mBeanServerConnection,
					jmxHelper);
			logger.debug("got inst mapping object name: " + instMappingObjectName);
			instMappingMap = (Map) mBeanServerConnection.getAttribute(instMappingObjectName, "InstitutionMappings");
			logger.debug("finished invoking getMappings");

		} catch (UnsupportedEncodingException e) {

			logger.error(e);
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.institutionmapping"));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);

		} catch (VistaLinkMBeanNotFoundException e) {
			// special catch here so we can display special error message for case where MBean is not
			// registered, meaning VL probably not deployed
			// no logger.error necessary
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.institutionMBeanFound"));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (IOException e) {
			// special catch here so we can display special error message for case where could not connect to server
			// no logger.error necessary
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.serverNotRunning"));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (ServerHelperNotRunningException e) {
			// don't log error, server not running is common condition
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (ServerHelperException e) {
			logger.error(e);
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.connector", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} catch (NoAccessRuntimeException e) {
			logger.warn("Access attempt without sufficient privileges" + e.getMessage());
			ActionErrors errors = getGlobalActionErrors(request);
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("configurator.nopriv", new Object[] { e
					.getMessage() }));
			request.setAttribute(Globals.ERROR_KEY, errors);
		} catch (Exception e) {
			logger.error("Problem rendering institution mapping page: ", e);
			ActionErrors actionErrors = new ActionErrors();
			actionErrors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("no.institutionGenericError"));
			request.setAttribute(Globals.ERROR_KEY, actionErrors);
		} finally {
			if (jmxConnector != null) {
				try {
					jmxConnector.close();
				} catch (IOException e) {
					logger.error("Error closing JMX Connector: ", e);
				}
			}
			request.setAttribute(INST_MAPPING_VO_ATTR_KEY, instMappingMap);
			request.setAttribute("server", serverTO);
		}

		return mapping.findForward("success");
	}

	/**
	 * Get the full, platform-specific ObjectName for the gov.va.med:vistalink.management.VistaLinkInstitutionMapping
	 * MBean as deployed.
	 * 
	 * @param mBeanServerConnection
	 * @param jmxHelper
	 * @return
	 * @throws VistaLinkMBeanNotFoundException
	 * @throws MalformedObjectNameException
	 * @throws IOException
	 */
	private ObjectName getVistaLinkInstitutionMappingObjectNameViaQuery(MBeanServerConnection mBeanServerConnection,
			IJmxHelper jmxHelper) throws VistaLinkMBeanNotFoundException, MalformedObjectNameException, IOException {

		ObjectName instMappingObjectName = null;
		StringBuffer sb = new StringBuffer(jmxHelper.getJmxDomainForHev());
		sb.append(":Type=").append(VistaLinkInstitutionMapping.getMBeanType()).append(",*");
		ObjectName queryObjectName = new ObjectName(sb.toString());
		logger.debug("About to query with ObjectName: " + queryObjectName);

		Set instMappingObjectNameSet = mBeanServerConnection.queryNames(queryObjectName, null);

		logger.debug("peformed queryMBeans");
		if (instMappingObjectNameSet.size() != 1) {
			logger.error("Expected 1 MBean, but MBean return set size was: " + instMappingObjectNameSet.size());
			throw new VistaLinkMBeanNotFoundException();
		} else {
			instMappingObjectName = (ObjectName) instMappingObjectNameSet.iterator().next();
			logger.debug("got inst mapping object name");
		}
		return instMappingObjectName;
	}
}